﻿

unchecked
{
    sbyte a = 127;
    a++;
    Console.WriteLine($"sbyte unchecked: {a}");
    a = sbyte.MinValue;
    a--;
    Console.WriteLine($"sbyte unchecked: {a}");
}

unchecked
{
    Int3 n = 0x007F_FFFF;
    n++;
    Console.WriteLine($"Int3 unchecked: {n}");
    n = Int3.MinValue;
    n--;
    Console.WriteLine($"Int3 unchecked: {n}");
}

Console.WriteLine();

unchecked
{
    sbyte n = sbyte.MinValue;
    sbyte value = (sbyte)-n;
    Console.WriteLine(value);
}

unchecked
{
    sbyte n = sbyte.MinValue;
    n++;
    sbyte value = (sbyte)-n;
    Console.WriteLine(value);
}

unchecked
{
    Int3 n = Int3.MinValue;
    Int3 value = -n;
    Console.WriteLine(value);
}

unchecked
{
    Int3 n = Int3.MinValue;
    n++;
    Int3 value = -n;
    Console.WriteLine(value);
}

Console.WriteLine();

unchecked
{
    sbyte n = sbyte.MinValue;
    n = (sbyte)(n - 2);
    Console.WriteLine(n);
}

unchecked
{
    sbyte n = sbyte.MinValue;
    n = (sbyte)(n + 2);
    sbyte value = (sbyte)-n;
    Console.WriteLine(value);
}

unchecked
{
    Int3 n = Int3.MinValue;
    n = n - 2;
    Console.WriteLine(n);
}

unchecked
{
    Int3 n = Int3.MinValue;
    n = n + 2;
    Int3 value = -n;
    Console.WriteLine(value);
}

public struct Int3
{
    public static Int3 MaxValue = new Int3(8388607);
    public static Int3 MinValue = new Int3(-8388608);

    int value;

    public Int3(int value) : this(value, false) { }

    public Int3(int value, bool checkOverflow)
    {
        int checkValue = value;

        if (value > 8388607)
        {
            checkValue = -(value & 0x00FF_FFFF);
        }
        else if (value < -8388608)
        {
            checkValue = value & 0x007F_FFFF;
        }

        if (checkOverflow == true)
        {
            if (value != checkValue)
            {
                throw new OverflowException($"{checkValue}");
            }
        }

        this.value = checkValue;
    }

    public static implicit operator Int3(int value) => new Int3(value);

    public static Int3 operator checked ++(Int3 lhs) => new Int3(lhs.value + 1, true);
    public static Int3 operator ++(Int3 lhs) => new Int3(lhs.value + 1);

    public static Int3 operator checked --(Int3 lhs) => new Int3(lhs.value - 1, true);
    public static Int3 operator --(Int3 lhs) => new Int3(lhs.value - 1);

    public static Int3 operator checked *(Int3 lhs, Int3 rhs) => new Int3(lhs.value * rhs.value, true);
    public static Int3 operator *(Int3 lhs, Int3 rhs) => new Int3(lhs.value * rhs.value);

    public static Int3 operator checked +(Int3 lhs, Int3 rhs) => new Int3(lhs.value + rhs.value, true);
    public static Int3 operator +(Int3 lhs, Int3 rhs) => new Int3(lhs.value + rhs.value);

    public static Int3 operator checked -(Int3 lhs, Int3 rhs) => new Int3(lhs.value - rhs.value, true);
    public static Int3 operator -(Int3 lhs, Int3 rhs) => new Int3(lhs.value - rhs.value);

    public static Int3 operator checked -(Int3 lhs, int rhs) => new Int3(lhs.value - rhs, true);
    public static Int3 operator -(Int3 lhs, int rhs) => new Int3(lhs.value - rhs);

    public static Int3 operator checked -(Int3 lhs) => new Int3(-lhs.value, true);
    public static Int3 operator -(Int3 lhs) => new Int3(-lhs.value);


    public override string ToString()
    {
        return $"{value}";
    }
}